Index: .hgignore
===================================================================
--- .hgignore	(revision 1171)
+++ .hgignore	(revision 2931)
@@ -3,2 +3,3 @@
 \.htaccess
 public
+behat.yml
Index: Makefile
===================================================================
--- Makefile	(revision 2801)
+++ Makefile	(revision 2931)
@@ -19,7 +19,8 @@
 
 	## Remove tests directories and test stuff
-	rm -fr ./$(DC)/inc/libs/clearbricks/tests ./$(DC)/inc/libs/clearbricks/composer.* \
-	       ./$(DC)/inc/libs/clearbricks/.atoum.* ./$(DC)/inc/libs/clearbricks/vendor \
-	       ./$(DC)/inc/libs/clearbricks/bin ./$(DC)/inc/libs/clearbricks/_dist
+	rm -fr ./$(DC)/inc/libs/clearbricks/tests ./$(DC)/inc/libs/clearbricks/composer.*	\
+	       ./$(DC)/inc/libs/clearbricks/.atoum.* ./$(DC)/inc/libs/clearbricks/vendor	\
+	       ./$(DC)/inc/libs/clearbricks/bin ./$(DC)/inc/libs/clearbricks/_dist		\
+	       ./$(DC)/features ./$(DC)/travis ./$(DC)/behat.yml.dist ./$(DC)/composer.*
 
 	## Create cache, db, plugins and public folders
@@ -67,4 +68,5 @@
 	find ./$(DIST)/ -type d -name '.git' | xargs -r rm -rf
 	find ./$(DIST)/ -type f -name '.*ignore' | xargs -r rm -rf
+	find ./$(DIST)/ -type f -name '.flow' | xargs -r rm -rf
 
 	## Create digest
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 2853)
+++ admin/preferences.php	(revision 2899)
@@ -352,26 +352,4 @@
 );
 
-if (!empty($_GET['upd'])) {
-	dcPage::success(__('Personal information has been successfully updated.'));
-}
-if (!empty($_GET['updated'])) {
-	dcPage::success(__('Personal options has been successfully updated.'));
-}
-if (!empty($_GET['db-updated'])) {
-	dcPage::success(__('Dashboard options has been successfully updated.'));
-}
-if (!empty($_GET['append'])) {
-	dcPage::success(__('Favorites have been successfully added.'));
-}
-if (!empty($_GET['neworder'])) {
-	dcPage::success(__('Favorites have been successfully updated.'));
-}
-if (!empty($_GET['removed'])) {
-	dcPage::success(__('Favorites have been successfully removed.'));
-}
-if (!empty($_GET['replaced'])) {
-	dcPage::success(__('Default favorites have been successfully updated.'));
-}
-
 # User profile
 echo '<div class="multi-part" id="user-profile" title="'.__('My profile').'">';
Index: behat.yml.dist
===================================================================
--- behat.yml.dist	(revision 2931)
+++ behat.yml.dist	(revision 2931)
@@ -0,0 +1,25 @@
+default:
+  context:
+    parameters:
+      base_url: http://localhost:1080
+
+      config_file: inc/config.php
+      sql_init_file: features/sql/db_init.sql
+      sql_cleanup_file: features/sql/db_cleanup.sql
+
+  extensions:
+    Behat\MinkExtension\Extension:
+      base_url: http://localhost:1080
+      goutte: ~
+
+  paths:
+    features:  features
+    bootstrap: features/bootstrap
+
+annotations:
+  paths:
+    features: features/annotations
+
+closures:
+  paths:
+    features: features/closures
Index: bin/atoum
===================================================================
--- bin/atoum	(revision 2931)
+++ bin/atoum	(revision 2931)
@@ -0,0 +1,1 @@
+../vendor/atoum/atoum/bin/atoum
Index: bin/behat
===================================================================
--- bin/behat	(revision 2931)
+++ bin/behat	(revision 2931)
@@ -0,0 +1,1 @@
+../vendor/behat/behat/bin/behat
Index: build-tools/setup.php
===================================================================
--- build-tools/setup.php	(revision 2933)
+++ build-tools/setup.php	(revision 2933)
@@ -0,0 +1,33 @@
+<?php
+$license_block = <<<EOF
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2015 Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+EOF;
+
+$dc_base = dirname(__FILE__).'/..';
+$php_exec = $_SERVER['_'];
+
+$opts = array(
+	'http' => array()
+);
+if (getenv('http_proxy') !== false) {
+	$opts['http']['proxy'] = 'tcp://'.getenv('http_proxy');
+}
+$context = stream_context_create($opts);
+
+if (!file_exists($dc_base.'/composer.phar')) {
+	echo "Downloading composer.phar\n";
+	$composer_installer = file_get_contents('https://getcomposer.org/composer.phar',false,$context);
+	file_put_contents($dc_base.'/composer.phar',$composer_installer);
+}
+chdir($dc_base);
+echo 'Running '.$php_exec.' composer.phar install'."\n";
+passthru ($php_exec.' composer.phar install');
Index: features/admin/session.feature
===================================================================
--- features/admin/session.feature	(revision 2931)
+++ features/admin/session.feature	(revision 2931)
@@ -0,0 +1,29 @@
+Feature: Manage content
+  In order to manage my blog
+  As an administrator
+  I need to be able to connect to administration area
+
+  Background: init
+    Given a user:
+      | username | password | status |
+      | user1    | pass1    | normal |
+
+  Scenario: Login
+    Given I am on "/admin/"
+    And I am logged in as "user1" with password "pass1"
+    Then I should see "Dashboard"
+    And I should see "My preferences"
+
+  Scenario: Logout
+    Given I am on "/admin/"
+    And I am logged in as "user1" with password "pass1"
+    When I follow "My preferences"
+    When I follow "Logout"
+    Then I should not see "My preferences"
+
+  Scenario: Remember me
+    Given I am on "/admin/"
+    And I am logged in as "user1" with password "pass1" with remember me
+    Then I should see "My preferences"
+    When I restart my browser
+    Then I should see "My preferences"
Index: features/bootstrap/DbContext.php
===================================================================
--- features/bootstrap/DbContext.php	(revision 2931)
+++ features/bootstrap/DbContext.php	(revision 2931)
@@ -0,0 +1,121 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+use Behat\MinkExtension\Context\RawMinkContext;
+use Behat\Behat\Event\SuiteEvent;
+use Behat\Behat\Event\ScenarioEvent;
+use Behat\Gherkin\Node\TableNode;
+
+include_once __DIR__.'/autoload.php';
+
+class DbContext extends RawMinkContext
+{
+    private static $conf_loaded = false;
+    private static $con = null;
+    public static $prefix = 'dc_';
+
+    public function __construct($parameters) {
+        $this->parameters = $parameters;
+    }
+
+    /**
+     * @Given /^a user:$/
+     */
+    public function aUser(TableNode $table) {
+        foreach ($table->getHash() as $user) {
+            $this->last_id = self::addUser($user);
+        }
+    }
+
+    /*
+    /* ORM methods
+    **/
+    /**
+     * @BeforeSuite
+     */
+    public static function prepareDB(SuiteEvent $event) {
+        $parameters = $event->getContextParameters();
+
+        if (empty($parameters['config_file']) || !is_readable($parameters['config_file'])) {
+            throw new Exception(sprintf('Config file %s does not exist or not readable', $parameters['config_file']));
+        }
+        if (empty($parameters['sql_init_file'])  || !is_readable($parameters['sql_init_file'])) {
+            throw new Exception(sprintf('sql init file %s does not exist or not readable', $parameters['sql_init_file']));
+        }
+        self::getConnection($parameters);
+        self::executeSqlFile($parameters['sql_init_file']);
+    }
+
+    /**
+     * @AfterScenario
+     */
+    public static function cleanDB(ScenarioEvent $event) {
+        $parameters = $event->getContext()->parameters;
+
+        if (empty($parameters['config_file']) || !is_readable($parameters['config_file'])) {
+            throw new Exception(sprintf('Config file %s does not exist or not readable', $parameters['config_file']));
+        }
+        self::getConnection($parameters);
+
+        if (empty($parameters['sql_cleanup_file']) && !is_readable($parameters['sql_cleanup_file'])) {
+            throw new Exception(sprintf('sql cleanup file %s does not exist or not readable', $parameters['sql_cleanup_file']));
+        }
+        self::executeSqlFile($parameters['sql_cleanup_file']);
+   }
+
+    private function addUser(array $params) {
+        self::getConnection($this->parameters);
+        if (empty($params['username']) || empty($params['password'])) {
+            throw new Exception('Username and Password for user are mandatory'."\n");
+        }
+        $strReq = 'SELECT count(1) FROM '.self::$prefix.'user';
+        $strReq .= ' WHERE user_id = \''.self::$con->escape($params['username']).'\'';
+        if ((int) self::$con->select($strReq)->f(0)==0) {
+            $user = self::$con->openCursor(self::$prefix . 'user');
+            $user->user_id = $params['username'];
+			$user->user_pwd = \crypt::hmac(DC_MASTER_KEY,$params['password']);
+            $user->user_super = 1;
+            $user->insert();
+        }
+    }
+
+    /**
+     *  Create a database connexion if none exists
+     */
+    private static function getConnection($parameters) {
+        if (!self::$conf_loaded) {
+            // @TODO : find a better way to include conf without define DC_RC_PATH
+            define('DC_RC_PATH', $parameters['config_file']);
+
+            include($parameters['config_file']);
+            self::$conf_loaded = true;
+            self::$prefix = DC_DBPREFIX;
+
+            self::$con = \dbLayer::init(DC_DBDRIVER,DC_DBHOST,DC_DBNAME,DC_DBUSER,DC_DBPASSWORD,DC_DBPERSIST);
+        }
+    }
+
+    private static function executeSqlFile($file) {
+        $queries = file($file);
+        if (!empty($queries)) {
+            try {
+                foreach ($queries as $query) {
+                    if (!empty($query)) {
+                        self::$con->execute($query);
+                    }
+                }
+            } catch (\Exception $e) {
+                // @TODO : make something ; exception thrown "database schema has changed (17)" ???
+            }
+        }
+    }
+}
Index: features/bootstrap/FeatureContext.php
===================================================================
--- features/bootstrap/FeatureContext.php	(revision 2931)
+++ features/bootstrap/FeatureContext.php	(revision 2931)
@@ -0,0 +1,61 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+use Behat\MinkExtension\Context\MinkContext;
+use Behat\Behat\Exception\PendingException;
+use Behat\Gherkin\Node\TableNode;
+
+/**
+ * Features context.
+ */
+class FeatureContext extends MinkContext
+{
+    /**
+     * Initializes context.
+     * Every scenario gets its own context object.
+     *
+     * @param array $parameters context parameters (set them up through behat.yml)
+     */
+    public function __construct(array $parameters) {
+        $this->parameters = $parameters;
+
+        $this->useContext('db', new DbContext($parameters));
+    }
+
+    /**
+     * @Given /^I am logged in as "([^"]*)" with password "([^"]*)"$/
+     */
+    public function iAmLoggedInAsWithPassword($username, $password, $remember=false) {
+        $this->fillField('Username', $username);
+        $this->fillField('Password', $password);
+        if ($remember) {
+            $this->checkOption('user_remember');
+        }
+        $this->pressButton('log in');
+    }
+
+    /**
+     * @Given /^I am logged in as "([^"]*)" with password "([^"]*)" with remember me$/
+     */
+    public function iAmLoggedInAsWithPasswordWithRememberMe($username, $password) {
+        $this->iAmLoggedInAsWithPassword($username, $password, true);
+        $this->getMink()->assertSession()->cookieExists('dcxd'); // @TODO : retrieve cookie name from config
+        $this->getMink()->assertSession()->cookieExists('dc_admin');
+    }
+
+    /**
+     * @When /^I restart my browser$/
+     */
+    public function iRestartMyBrowser() {
+        $this->getMink()->assertSession()->cookieExists('dcxd');
+    }
+}
Index: features/bootstrap/autoload.php
===================================================================
--- features/bootstrap/autoload.php	(revision 2931)
+++ features/bootstrap/autoload.php	(revision 2931)
@@ -0,0 +1,34 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+define('CLEARBRICKS_PATH',__DIR__.'/../../inc/libs/clearbricks');
+
+require_once __DIR__.'/../../vendor/autoload.php';
+
+include_once '/var/projets/common/Log.php';
+
+$__autoload = array();
+$__autoload['dbStruct'] = CLEARBRICKS_PATH.'/dbschema/class.dbstruct.php';
+$__autoload['dbSchema'] = CLEARBRICKS_PATH.'/dbschema/class.dbschema.php';
+$__autoload['pgsqlSchema'] = CLEARBRICKS_PATH.'/dbschema/class.pgsql.dbschema.php';
+$__autoload['mysqlSchema'] = CLEARBRICKS_PATH.'/dbschema/class.mysql.dbschema.php';
+$__autoload['mysqliSchema'] = CLEARBRICKS_PATH.'/dbschema/class.mysqli.dbschema.php';
+$__autoload['dbLayer'] = CLEARBRICKS_PATH.'/dblayer/dblayer.php';
+$__autoload['mysqlConnection'] = CLEARBRICKS_PATH.'/dblayer/class.mysql.php';
+$__autoload['mysqliConnection'] = CLEARBRICKS_PATH.'/dblayer/class.mysqli.php';
+$__autoload['pgsqlConnection'] = CLEARBRICKS_PATH.'/dblayer/class.pgsql.php';
+$__autoload['crypt'] = CLEARBRICKS_PATH.'/common/lib.crypt.php';
+
+
+$loader = new \Composer\Autoload\ClassLoader();
+$loader->addClassMap($__autoload);
+$loader->register();
Index: features/public/home.feature
===================================================================
--- features/public/home.feature	(revision 2931)
+++ features/public/home.feature	(revision 2931)
@@ -0,0 +1,8 @@
+Feature: See content
+  In order to see posts
+  As a site visitor
+  I need to be able to see the website
+
+  Scenario: I'm on a dotclear blog
+    Given I am on homepage
+    Then I should see "Powered by dotclear"
Index: features/sql/db_cleanup.sql
===================================================================
--- features/sql/db_cleanup.sql	(revision 2931)
+++ features/sql/db_cleanup.sql	(revision 2931)
@@ -0,0 +1,1 @@
+DELETE FROM dc_user;
Index: features/sql/db_init.sql
===================================================================
--- features/sql/db_init.sql	(revision 2931)
+++ features/sql/db_init.sql	(revision 2931)
@@ -0,0 +1,1 @@
+UPDATE dc_user SET user_lang = 'en';
Index: inc/core/class.dc.modules.php
===================================================================
--- inc/core/class.dc.modules.php	(revision 2708)
+++ inc/core/class.dc.modules.php	(revision 2918)
@@ -114,7 +114,7 @@
 		uasort($this->modules,array($this,'sortModules'));
 
-		# Load translation, _prepend and ns_file
 		foreach ($this->modules as $id => $m)
 		{
+			# Load translation and _prepend
 			if (file_exists($m['root'].'/_prepend.php'))
 			{
@@ -133,4 +133,8 @@
 				$this->core->adminurl->register('admin.plugin.'.$id,'plugin.php',array('p'=>$id));
 			}
+		}
+		foreach ($this->modules as $id => $m)
+		{
+			# Load ns_file
 			$this->loadNsFile($id,$ns);
 		}
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2934)
+++ inc/prepend.php	(revision 2937)
@@ -140,5 +140,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.7.4');
+define('DC_VERSION','2.8-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: plugins/simpleMenu/_public.php
===================================================================
--- plugins/simpleMenu/_public.php	(revision 2912)
+++ plugins/simpleMenu/_public.php	(revision 2928)
@@ -31,5 +31,5 @@
 		$description = isset($attr['description']) ? trim($attr['description']) : '';
 
-		if (!preg_match('#^(title|span)$#',$description)) {
+		if (!preg_match('#^(title|span|both|none)$#',$description)) {
 			$description = '';
 		}
@@ -47,4 +47,6 @@
 		global $core, $_ctx;
 
+		$descr_type = array(0 => 'span',1 => 'title',2 => 'both',3 => 'none');
+
 		if (!(boolean) $core->blog->settings->system->simpleMenu_active)
 			return;
@@ -58,5 +60,9 @@
 		}
 
-		$menu = tplSimpleMenu::displayMenu('','','title');
+		$description = 'title';
+		if (isset($descr_type[$w->description])) {
+			$description = $descr_type[$w->description];
+		}
+		$menu = tplSimpleMenu::displayMenu('','',$description);
 		if ($menu == '') {
 			return;
@@ -107,7 +113,8 @@
 				$title = $span = '';
 				if ($m['descr']) {
-					if ($description == 'title') {
+					if ($description == 'title' || $description == 'both') {
 						$title = ' title="'.html::escapeHTML(__($m['descr'])).'"';
-					} else {
+					}
+					if ($description == 'span' || $description == 'both') {
 						$span = ' <span>'.html::escapeHTML(__($m['descr'])).'</span>';
 					}
Index: plugins/simpleMenu/_widgets.php
===================================================================
--- plugins/simpleMenu/_widgets.php	(revision 2778)
+++ plugins/simpleMenu/_widgets.php	(revision 2928)
@@ -20,4 +20,12 @@
 		$w->create('simplemenu',__('Simple menu'),array('tplSimpleMenu','simpleMenuWidget'),null,'List of simple menu items');
 		$w->simplemenu->setting('title',__('Title (optional)').' :',__('Menu'));
+		$w->simplemenu->setting('description',__('Item description'),0,'combo',
+			array(
+				__('Displayed in link') => 0,					// span
+				__('Used as link title') => 1,					// title
+				__('Displayed in link and used as title') => 2,	// both
+				__('Not displayed nor used') => 3 				// none
+				)
+			);
 		$w->simplemenu->setting('homeonly',__('Display on:'),0,'combo',
 			array(
@@ -26,5 +34,5 @@
 				__('Except on home page') => 2
 				)
-		);
+			);
 		$w->simplemenu->setting('content_only',__('Content only'),0,'check');
 		$w->simplemenu->setting('class',__('CSS class:'),'');
Index: plugins/tags/_admin.php
===================================================================
--- plugins/tags/_admin.php	(revision 2849)
+++ plugins/tags/_admin.php	(revision 2924)
@@ -10,4 +10,5 @@
 #
 # -- END LICENSE BLOCK -----------------------------------------
+
 if (!defined('DC_CONTEXT_ADMIN')) { return; }
 
@@ -36,350 +37,8 @@
 $core->addBehavior('adminBeforeUserUpdate',array('tagsBehaviors','setTagListFormat'));
 
-$core->addBehavior('coreInitWikiPost',array('tagsBehaviors','coreInitWikiPost'));
-
 $core->addBehavior('adminDashboardFavorites',array('tagsBehaviors','dashboardFavorites'));
 
 $core->addBehavior('adminPageHelpBlock', array('tagsBehaviors', 'adminPageHelpBlock'));
 
+$core->addBehavior('adminPostEditor', array('tagsBehaviors','adminPostEditor'));
 $core->addBehavior('ckeditorExtraPlugins', array('tagsBehaviors', 'ckeditorExtraPlugins'));
-
-# BEHAVIORS
-class tagsBehaviors
-{
-    public static function ckeditorExtraPlugins(ArrayObject $extraPlugins, $context)
-    {
-        global $core;
-
-        if ($context!='post') {
-            return;
-        }
-        $extraPlugins[] = array(
-            'name' => 'dctags',
-            'button' => 'dcTags',
-            'url' => DC_ADMIN_URL.'index.php?pf=tags/js/ckeditor-tags-plugin.js'
-        );
-    }
-
-	public static function adminPageHelpBlock($blocks)
-	{
-		$found = false;
-		foreach($blocks as $block) {
-			if ($block == 'core_post') {
-				$found = true;
-				break;
-			}
-		}
-		if (!$found) {
-			return null;
-		}
-		$blocks[] = 'tag_post';
-	}
-
-	public static function dashboardFavorites($core,$favs)
-	{
-		$favs->register('tags', array(
-			'title' => __('Tags'),
-			'url' => $core->adminurl->get('admin.plugin.tags',array('m' => 'tags')),
-			'small-icon' => dcPage::getPF('tags/icon.png'),
-			'large-icon' => dcPage::getPF('tags/icon-big.png'),
-			'permissions' => 'usage,contentadmin'
-		));
-	}
-
-	public static function coreInitWikiPost($wiki2xhtml)
-	{
-		$wiki2xhtml->registerFunction('url:tag',array('tagsBehaviors','wiki2xhtmlTag'));
-	}
-
-	public static function wiki2xhtmlTag($url,$content)
-	{
-		$url = substr($url,4);
-		if (strpos($content,'tag:') === 0) {
-			$content = substr($content,4);
-		}
-
-
-		$tag_url = html::stripHostURL($GLOBALS['core']->blog->url.$GLOBALS['core']->url->getURLFor('tag'));
-		$res['url'] = $tag_url.'/'.rawurlencode(dcMeta::sanitizeMetaID($url));
-		$res['content'] = $content;
-
-		return $res;
-	}
-
-	public static function tagsField($main,$sidebar,$post)
-	{
-		$meta =& $GLOBALS['core']->meta;
-
-		if (!empty($_POST['post_tags'])) {
-			$value = $_POST['post_tags'];
-		} else {
-			$value = ($post) ? $meta->getMetaStr($post->post_meta,'tag') : '';
-		}
-		$sidebar['metas-box']['items']['post_tags']=
-		'<h5><label class="s-tags" for="post_tags">'.__('Tags').'</label></h5>'.
-		'<div class="p s-tags" id="tags-edit">'.form::textarea('post_tags',20,3,$value,'maximal').'</div>';
-	}
-
-	public static function setTags($cur,$post_id)
-	{
-		$post_id = (integer) $post_id;
-
-		if (isset($_POST['post_tags'])) {
-			$tags = $_POST['post_tags'];
-			$meta =& $GLOBALS['core']->meta;
-			$meta->delPostMeta($post_id,'tag');
-
-			foreach ($meta->splitMetaValues($tags) as $tag) {
-				$meta->setPostMeta($post_id,'tag',$tag);
-			}
-		}
-	}
-
-
-	public static function adminPostsActionsPage($core,$ap)
-	{
-		$ap->addAction(
-			array(__('Tags') => array(__('Add tags') => 'tags')),
-			array('tagsBehaviors','adminAddTags')
-		);
-
-		if ($core->auth->check('delete,contentadmin',$core->blog->id)) {
-			$ap->addAction(
-				array(__('Tags') => array(__('Remove tags') => 'tags_remove')),
-				array('tagsBehaviors','adminRemoveTags')
-			);
-		}
-	}
-
-	public static function adminAddTags($core, dcPostsActionsPage $ap, $post)
-	{
-		if (!empty($post['new_tags']))
-		{
-			$meta =& $core->meta;
-			$tags = $meta->splitMetaValues($post['new_tags']);
-			$posts = $ap->getRS();
-			while ($posts->fetch())
-			{
-				# Get tags for post
-				$post_meta = $meta->getMetadata(array(
-					'meta_type' => 'tag',
-					'post_id' => $posts->post_id));
-				$pm = array();
-				while ($post_meta->fetch()) {
-					$pm[] = $post_meta->meta_id;
-				}
-				foreach ($tags as $t) {
-					if (!in_array($t,$pm)) {
-						$meta->setPostMeta($posts->post_id,'tag',$t);
-					}
-				}
-			}
-			dcPage::addSuccessNotice(sprintf(
-				__(
-					'Tag has been successfully added to selected entries',
-					'Tags have been successfully added to selected entries',
-					count($tags))
-				)
-			);
-			$ap->redirect(true);
-		}
-		else
-		{
-			$tag_url = $core->blog->url.$core->url->getURLFor('tag');
-
-			$opts = $core->auth->getOptions();
-			$type = isset($opts['tag_list_format']) ? $opts['tag_list_format'] : 'more';
-
-
-			$ap->beginPage(
-				dcPage::breadcrumb(
-					array(
-						html::escapeHTML($core->blog->name) => '',
-						__('Entries') => $ap->getRedirection(true),
-						__('Add tags to this selection') => ''
-				)),
-				dcPage::jsLoad('js/jquery/jquery.autocomplete.js').
-				dcPage::jsMetaEditor().
-				'<script type="text/javascript">'."\n".
-				"//<![CDATA[\n".
-				"var editor_tags_options = {\n".
-					"meta_url : 'plugin.php?p=tags&m=tag_posts&amp;tag=',\n".
-					"list_type : '".html::escapeJS($type)."',\n".
-					"text_confirm_remove : '".html::escapeJS(__('Are you sure you want to remove this tag?'))."',\n".
-					"text_add_meta : '".html::escapeJS(__('Add a tag to this entry'))."',\n".
-					"text_choose : '".html::escapeJS(__('Choose from list'))."',\n".
-					"text_all : '".html::escapeJS(__('all'))."',\n".
-					"text_separation : '".html::escapeJS(__('Enter tags separated by coma'))."',\n".
-				"};\n".
-				"\n//]]>\n".
-				"</script>\n".
-				'<script type="text/javascript" src="index.php?pf=tags/js/jquery.autocomplete.js"></script>'.
-				'<script type="text/javascript" src="index.php?pf=tags/js/posts_actions.js"></script>'.
-				'<script type="text/javascript">'."\n".
-				"//<![CDATA[\n".
-				"dotclear.msg.tags_autocomplete = '".html::escapeJS(__('used in %e - frequency %p%'))."';\n".
-				"dotclear.msg.entry = '".html::escapeJS(__('entry'))."';\n".
-				"dotclear.msg.entries = '".html::escapeJS(__('entries'))."';\n".
-				"\n//]]>\n".
-				"</script>\n".
-				'<link rel="stylesheet" type="text/css" href="index.php?pf=tags/style.css" />'
-			);
-			echo
-				'<form action="'.$ap->getURI().'" method="post">'.
-				$ap->getCheckboxes().
-				'<div><label for="new_tags" class="area">'.__('Tags to add:').'</label> '.
-				form::textarea('new_tags',60,3).
-				'</div>'.
-				$core->formNonce().$ap->getHiddenFields().
-				form::hidden(array('action'),'tags').
-				'<p><input type="submit" value="'.__('Save').'" '.
-				'name="save_tags" /></p>'.
-				'</form>';
-			$ap->endPage();
-		}
-	}
-	public static function adminRemoveTags($core, dcPostsActionsPage $ap, $post)
-	{
-		if (!empty($post['meta_id']) &&
-			$core->auth->check('delete,contentadmin',$core->blog->id))
-		{
-			$meta =& $core->meta;
-			$posts = $ap->getRS();
-			while ($posts->fetch())
-			{
-				foreach ($_POST['meta_id'] as $v)
-				{
-					$meta->delPostMeta($posts->post_id,'tag',$v);
-				}
-			}
-			dcPage::addSuccessNotice(sprintf(
-				__(
-					'Tag has been successfully removed from selected entries',
-					'Tags have been successfully removed from selected entries',
-					count($_POST['meta_id']))
-				)
-			);
-			$ap->redirect(true);
-		}
-		else
-		{
-			$meta =& $core->meta;
-			$tags = array();
-
-			foreach ($ap->getIDS() as $id) {
-				$post_tags = $meta->getMetadata(array(
-					'meta_type' => 'tag',
-					'post_id' => (integer) $id))->toStatic()->rows();
-				foreach ($post_tags as $v) {
-					if (isset($tags[$v['meta_id']])) {
-						$tags[$v['meta_id']]++;
-					} else {
-						$tags[$v['meta_id']] = 1;
-					}
-				}
-			}
-			if (empty($tags)) {
-				throw new Exception(__('No tags for selected entries'));
-			}
-			$ap->beginPage(
-				dcPage::breadcrumb(
-						array(
-							html::escapeHTML($core->blog->name) => '',
-							__('Entries') => 'posts.php',
-							__('Remove selected tags from this selection') => ''
-			)));
-			$posts_count = count($_POST['entries']);
-
-			echo
-			'<form action="'.$ap->getURI().'" method="post">'.
-			$ap->getCheckboxes().
-			'<div><p>'.__('Following tags have been found in selected entries:').'</p>';
-
-			foreach ($tags as $k => $n) {
-				$label = '<label class="classic">%s %s</label>';
-				if ($posts_count == $n) {
-					$label = sprintf($label,'%s','<strong>%s</strong>');
-				}
-				echo '<p>'.sprintf($label,
-						form::checkbox(array('meta_id[]'),html::escapeHTML($k)),
-						html::escapeHTML($k)).
-					'</p>';
-			}
-
-			echo
-			'<p><input type="submit" value="'.__('ok').'" />'.
-
-			$core->formNonce().$ap->getHiddenFields().
-			form::hidden(array('action'),'tags_remove').
-			'</p></div></form>';
-			$ap->endPage();
-		}
-
-	}
-
-	public static function postHeaders()
-	{
-		$tag_url = $GLOBALS['core']->blog->url.$GLOBALS['core']->url->getURLFor('tag');
-
-		$opts = $GLOBALS['core']->auth->getOptions();
-		$type = isset($opts['tag_list_format']) ? $opts['tag_list_format'] : 'more';
-
-		return
-		'<script type="text/javascript">'."\n".
-		"//<![CDATA[\n".
-		"var editor_tags_options = {\n".
-			"meta_url : 'plugin.php?p=tags&m=tag_posts&amp;tag=',\n".
-			"list_type : '".html::escapeJS($type)."',\n".
-			"text_confirm_remove : '".html::escapeJS(__('Are you sure you want to remove this tag?'))."',\n".
-			"text_add_meta : '".html::escapeJS(__('Add a tag to this entry'))."',\n".
-			"text_choose : '".html::escapeJS(__('Choose from list'))."',\n".
-			"text_all : '".html::escapeJS(__('all'))."',\n".
-			"text_separation : '".html::escapeJS(__('Enter tags separated by coma'))."',\n".
-		"};\n".
-		"\n//]]>\n".
-		"</script>\n".
-		'<script type="text/javascript" src="index.php?pf=tags/js/jquery.autocomplete.js"></script>'.
-		'<script type="text/javascript" src="index.php?pf=tags/js/post.js"></script>'.
-		'<script type="text/javascript">'."\n".
-		"//<![CDATA[\n".
-		"jsToolBar.prototype.elements.tag.title = '".html::escapeJS(__('Tag'))."';\n".
-		"jsToolBar.prototype.elements.tag.url = '".html::escapeJS($tag_url)."';\n".
-		"dotclear.msg.tags_autocomplete = '".html::escapeJS(__('used in %e - frequency %p%'))."';\n".
-		"dotclear.msg.entry = '".html::escapeJS(__('entry'))."';\n".
-		"dotclear.msg.entries = '".html::escapeJS(__('entries'))."';\n".
-		"\n//]]>\n".
-		"</script>\n".
-		'<link rel="stylesheet" type="text/css" href="index.php?pf=tags/style.css" />';
-	}
-
-	public static function adminUserForm($args)
-	{
-		if ($args instanceof dcCore) {
-			$opts = $args->auth->getOptions();
-		}
-		elseif ($args instanceof record) {
-			$opts = $args->options();
-		}
-		else {
-			$opts = array();
-		}
-
-		$combo = array();
-		$combo[__('Short')] = 'more';
-		$combo[__('Extended')] = 'all';
-
-		$value = array_key_exists('tag_list_format',$opts) ? $opts['tag_list_format'] : 'more';
-
-		echo
-		'<p><label for="user_tag_list_format" class="classic">'.__('Tags list format:').'</label> '.
-		form::combo('user_tag_list_format',$combo,$value).
-		'</p>';
-	}
-
-	public static function setTagListFormat($cur,$user_id = null)
-	{
-		if (!is_null($user_id)) {
-			$cur->user_options['tag_list_format'] = $_POST['user_tag_list_format'];
-		}
-	}
-}
Index: plugins/tags/_define.php
===================================================================
--- plugins/tags/_define.php	(revision 2662)
+++ plugins/tags/_define.php	(revision 2924)
@@ -16,8 +16,8 @@
 	/* Description*/		"Tags for posts",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.3',
+	/* Version */			'1.4',
 	array(
 		'permissions' =>	'usage,contentadmin',
-		'priority' =>		998,
+		'priority' =>		1001,	// Must be higher than dcLegacyEditor/dcCKEditor priority (ie 1000)
 		'type'		=>		'plugin'
 	)
Index: plugins/tags/_prepend.php
===================================================================
--- plugins/tags/_prepend.php	(revision 2095)
+++ plugins/tags/_prepend.php	(revision 2924)
@@ -10,4 +10,5 @@
 #
 # -- END LICENSE BLOCK -----------------------------------------
+
 if (!defined('DC_RC_PATH')) { return; }
 
@@ -15,2 +16,6 @@
 $core->url->register('tags', 'tags', '^tags$', array('urlTags', 'tags'));
 $core->url->register('tag_feed', 'feed/tag', '^feed/tag/(.+)$', array('urlTags', 'tagFeed'));
+
+$__autoload['tagsBehaviors'] = dirname(__FILE__).'/inc/tags.behaviors.php';
+
+$core->addBehavior('coreInitWikiPost',array('tagsBehaviors','coreInitWikiPost'));
